package be.iminds.ilabt.jfed.experimenter_gui.slice.tasks;

import be.iminds.ilabt.jfed.experimenter_gui.slice.Experiment;
import be.iminds.ilabt.jfed.highlevel.controller.Task;
import be.iminds.ilabt.jfed.highlevel.tasks.HighLevelTaskFactory;
import be.iminds.jfed.gts_highlevel.tasks.GtsTaskFactory;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * User: twalcari
 * Date: 2/2/2015
 * Time: 17:23
 */
public class UpdateExperimentTask extends MultipleCallExperimentTask {

    private final GtsTaskFactory gtsTaskFactory;

    UpdateExperimentTask(Experiment experiment, HighLevelTaskFactory hltf, GtsTaskFactory gtsTaskFactory) {
        super(experiment, hltf);
        this.gtsTaskFactory = gtsTaskFactory;

        updateTitle("Update experiment status");
    }

    @Override
    public Collection<Task> createTasks() {
        List<Task> tasks = new ArrayList<>();

        tasks.add(hltf.getSliceStatus(experiment.getSlice()));

        //also update GTS resources if there are any in the experiment
        if (experiment.getGtsProject() != null)
            tasks.add(gtsTaskFactory.createGtsListResourcesTask(experiment.getGtsProject()));

        return tasks;
    }
}
